#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MAKSM = 50;
const int MAKSGRPS = MAKSM * MAKSM + 13;

long long N, M, x, y, a, b, c, res;
vector<pair<long long, long long> > points;
vector<tuple<long long, long long, long long> > lines;
vector<long long> pointsMasks;
set<long long> parsedPointsSet;
set<pair<int, int> > s;
bool vis[MAKSGRPS];

bool isUnder(int ptNr, int lNr) {
    tie(x, y) = points[ptNr];
    tie(a, b, c) = lines[lNr];
    long long val = a * x + b * y + c;
    return val < 0;
}

void changePointsToBitMasks() {
    for (int i = 0; i < (int)points.size(); i++) {
        long long mask = 0ll;
        for (int j = 0; j < (int)lines.size(); j++) {
            if (isUnder(i, j)) {
                mask |= (1ll << j);
            }
        }
        parsedPointsSet.insert(mask);
    }

    for (auto pt : parsedPointsSet) {
        pointsMasks.push_back(pt);
    }
}

int dist(long long maska, long long maskb) {
    return __builtin_popcountll(maska ^ maskb);
}

void buildMST() {
    res = 0;
    // start at parsedPoints[0]
    s.insert({0, 0});

    while (!s.empty()) {
        auto p = *(s.begin());
        int di = p.first;
        int v = p.second;
        s.erase(p);

        if (vis[v])
            continue;

        vis[v] = true;
        res += di;

        for (int i = 0; i < (int)pointsMasks.size(); i++) {
            if (vis[i])
                continue;
            s.insert({dist(pointsMasks[v], pointsMasks[i]), i});
        }
    }
}

void solve() {
    changePointsToBitMasks();
    buildMST();
    cout << res << "\n";
}

void readInput() {
    cin >> N;
    for (int i = 0; i < N; i++) {
        cin >> x >> y;
        points.push_back({x, y});
    }

    cin >> M;

    for (int i = 0; i < M; i++) {
        cin >> a >> b >> c;
        lines.push_back({a, b, c});
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    readInput();
    solve();
    return 0;
}
